searchNodes=[{"doc":"The Ping extension defines different ping method.","ref":"Umbra.Extension.Ping.html","title":"Umbra.Extension.Ping","type":"behaviour"},{"doc":"This callback is called each time the server receives a ping.","ref":"Umbra.Extension.Ping.html#c:handle_ping/1","title":"Umbra.Extension.Ping.handle_ping/1","type":"callback"},{"doc":"The Umbra.GenServer is the only module users should care.You only need to use that module to get started.Example:defmodule MyGenServer do use Umbra.GenServer # your code endYou can use Behaviours to override the default Umbra.GenServer behaviour :Umbra.Behaviour.Default which is used by default.Umbra.Behaviour.Strict.Umbra.Behaviour.Tolerant.To use a specific Behaviour, you can do:defmodule MyGenServer do use Umbra.GenServer, behaviour: Umbra.GenServer.Tolerant endUmbra is overridable by callbacks, but you should use it at your own depends.You can also use Extensions to modify the behaviour of your GenServer :Umbra.Extension.NameSetterUmbra.Extension.Registry","ref":"Umbra.GenServer.html","title":"Umbra.GenServer","type":"behaviour"},{"doc":"This macro is used to create a fallback for __get_pid__/1 and __init__/1 callback.","ref":"Umbra.GenServer.html#__before_compile__/1","title":"Umbra.GenServer.__before_compile__/1","type":"macro"},{"doc":"This callback is used to retrieve the PID.t from the first argument of each client-side genserver function.Without any extensions, only PID.t are working.The Umbra.Extension.Registry extension did set this callback to retrieve the PID.t from the GenServer state/struct.","ref":"Umbra.GenServer.html#c:__get_pid__/1","title":"Umbra.GenServer.__get_pid__/1","type":"callback"},{"doc":"This callback is used to do some changement on state or just initialize some stuff for extensions.It's a callback which only should be override! You should call super(state) when success at the end of your own implementation.The Umbra.Extension.Ping extension did set this callback to initialize itself.","ref":"Umbra.GenServer.html#c:__init__/1","title":"Umbra.GenServer.__init__/1","type":"callback"},{"doc":"This callback is used behind the scene by Umbra to start the GenServer and can be overrided by extensions or user when needed.It's here to allow user/extensions to modify the options passed to GenServer.It's a callback which only should be override! You should call super(linked, state, opts) at the end of your own implementation.Example:defmodule MyGenServer do use Umbra.GenServer def __start__(linked, state, opts) do {_, opts} = Keyword.pop(opts, :debug) opts = opts ++ [debug: [:trace]] super(linked, state, opts) end endThe Umbra.Extension.NameSetter extension did set a Umbra.GenServer.__start__/3 override to automatically set the process name thanks to the Umbra.Extension.NameSetter.__get_process_name__/1 callback.Basically this callback only do:GenServer.start(__MODULE__, state, opts) # or start_link if `linked` == true","ref":"Umbra.GenServer.html#c:__start__/3","title":"Umbra.GenServer.__start__/3","type":"callback"},{"doc":"This macro is used to implements the requested behaviour, callbacks and generate start/2 and start_link/2 functions.","ref":"Umbra.GenServer.html#__using__/1","title":"Umbra.GenServer.__using__/1","type":"macro"},{"doc":"This module is used under the hood by all Umbra modules.It defines some helpers.","ref":"Umbra.Helper.html","title":"Umbra.Helper","type":"module"},{"doc":"This function is used to extract argument.It returns an atom corresponding to the argument name. When the function did fails, it raises ArgumentError.Example:iex&gt; Umbra.Helper.extract_argument(:my_arg) :my_arg iex&gt; Umbra.Helper.extract_argument(quote do: :my_arg) :my_arg iex&gt; Umbra.Helper.extract_argument(quote do: a_var) :a_var iex&gt; Umbra.Helper.extract_argument(quote do: :def) ** (ArgumentError) invalid argument iex&gt; Umbra.Helper.extract_argument(quote do: %{something: true}) ** (ArgumentError) invalid argument","ref":"Umbra.Helper.html#extract_argument/1","title":"Umbra.Helper.extract_argument/1","type":"function"},{"doc":"This function is used to extract function name and arguments.It returns a tuple with the function name and the arguments. When the function did fails, it raises ArgumentError.Example:iex&gt; Umbra.Helper.extract_definition(:get_state) {:get_state, []} iex&gt; Umbra.Helper.extract_definition(quote do: :get_state) {:get_state, []} iex&gt; Umbra.Helper.extract_definition(quote do: {:get_state}) {:get_state, []} iex&gt; Umbra.Helper.extract_definition(quote do: get_state()) {:get_state, []} iex&gt; Umbra.Helper.extract_definition(quote do: {:set_state, new_state}) {:set_state, [:new_state]} iex&gt; Umbra.Helper.extract_definition(quote do: set_state(new_state)) {:set_state, [:new_state]} iex&gt; Umbra.Helper.extract_definition(quote do: {:do_something, a, b}) {:do_something, [:a, :b]} iex&gt; Umbra.Helper.extract_definition(quote do: do_something(a, b)) {:do_something, [:a, :b]} iex&gt; Umbra.Helper.extract_definition(quote do: def(a)) ** (ArgumentError) invalid definition iex&gt; Umbra.Helper.extract_definition(quote do: my_func(def)) ** (ArgumentError) invalid argument iex&gt; Umbra.Helper.extract_definition(quote do: my_func(%{something: true})) ** (ArgumentError) invalid argument","ref":"Umbra.Helper.html#extract_definition/1","title":"Umbra.Helper.extract_definition/1","type":"function"},{"doc":"This macro help know if the given atom is a valid name for functions or variables. It should be used in when guards.Example: iex&gt; Umbra.Helper.var_name?(:toto) true iex&gt; Umbra.Helper.var_name?(:tata) true iex&gt; Umbra.Helper.var_name?(:%{}) false","ref":"Umbra.Helper.html#var_name?/1","title":"Umbra.Helper.var_name?/1","type":"macro"},{"doc":"Umbra.Operations","ref":"Umbra.Operations.html","title":"Umbra.Operations","type":"module"},{"doc":"","ref":"Umbra.Operations.html#defcall/3","title":"Umbra.Operations.defcall/3","type":"macro"},{"doc":"","ref":"Umbra.Operations.html#defcast/3","title":"Umbra.Operations.defcast/3","type":"macro"},{"doc":"","ref":"Umbra.Operations.html#defcontinue/3","title":"Umbra.Operations.defcontinue/3","type":"macro"},{"doc":"","ref":"Umbra.Operations.html#definfo/3","title":"Umbra.Operations.definfo/3","type":"macro"},{"doc":"","ref":"Umbra.Operations.html#definit/2","title":"Umbra.Operations.definit/2","type":"macro"},{"doc":"","ref":"Umbra.Operations.html#defstart/2","title":"Umbra.Operations.defstart/2","type":"macro"},{"doc":"Umbra.Behaviour.Default","ref":"Umbra.Behaviour.Default.html","title":"Umbra.Behaviour.Default","type":"module"},{"doc":"Umbra.Behaviour.Strict","ref":"Umbra.Behaviour.Strict.html","title":"Umbra.Behaviour.Strict","type":"module"},{"doc":"Umbra.Behaviour.Tolerant","ref":"Umbra.Behaviour.Tolerant.html","title":"Umbra.Behaviour.Tolerant","type":"module"},{"doc":"The extension Umbra.Extension.NameSetter is used to manage the GenServer name option.It overrides the Umbra.GenServer.__start__/3 callback to set the process name (only if missing from options) before starting the GenServer.This extension define a callback __get_process_name__/1 to retrieve/set name depending of the state when start_link/2 or start/2 of your GenServer are called.Example:defmodule MyGenServer do defstruct [:id, :other_states] use Umbra.GenServer use Umbra.Extension.NameSetter @impl Umbra.Extension.NameSetter def __get_process_name__(%__MODULE__{id: id}) do {:ok, &quot;MyGenServer::\#{id}&quot;} end # your code end","ref":"Umbra.Extension.NameSetter.html","title":"Umbra.Extension.NameSetter","type":"behaviour"},{"doc":"This macro is used to create a fallback for __get_process_name__/1 callback.","ref":"Umbra.Extension.NameSetter.html#__before_compile__/1","title":"Umbra.Extension.NameSetter.__before_compile__/1","type":"macro"},{"doc":"This callback is used to retrieve the process name depending of the parameter.It always returns {:ok, nil} except if extensions are used.The Umbra.Extension.Registry extension did set this callback to create the process name from the state thanks to a Registry (also called a via_name).You have to take care of the declaration orders.","ref":"Umbra.Extension.NameSetter.html#c:__get_process_name__/1","title":"Umbra.Extension.NameSetter.__get_process_name__/1","type":"callback"},{"doc":"This macro allow setting an override to the Umbra.GenServer.__start__/3 callback and define a __get_process_name__/1 callback fallback thanks to __before_compile__/1.","ref":"Umbra.Extension.NameSetter.html#__using__/1","title":"Umbra.Extension.NameSetter.__using__/1","type":"macro"},{"doc":"The Umbra.Extension.Registry extension allow user to use a Registry under the hood and automatically use the state to retrieve the Registry via_name tuple.Warning, it directly depends of the Umbra.Extension.NameSetter extension. You have to use it before using this extension.This extension requires defining a struct for your state.You shall define your Registry under a Supervisor tree.Example:defmodule MyGenServer do defstruct [:id, :other_states] use Umbra.GenServer use Umbra.Extension.NameSetter use Umbra.Extension.Registry, registry: MyRegistry, via_key: fn %__MODULE__{id: id} -&gt; id end # your code end # Start your Registry before trying to use the GenServer {:ok, _} = Registry.start_link(keys: :unique, name: MyRegistry) # Declare the state and start the GenServer with it state = %MyGenServer{ id: 2, data: 3 } {:ok, _} = MyGenServer.start_link(state) # You can use your GenServer directly with your struct instead of the PID state |&gt; MyGenServer.do_something(state)","ref":"Umbra.Extension.Registry.html","title":"Umbra.Extension.Registry","type":"module"},{"doc":"This macro is used to override Umbra.Extension.NameSetter.__get_process_name__/1 and Umbra.GenServer.__get_pid__/1 callbacks.","ref":"Umbra.Extension.Registry.html#__using__/1","title":"Umbra.Extension.Registry.__using__/1","type":"macro"},{"doc":"Umbra Umbra is a GenServer utility helping you to easily create GenServer module. It helps to reduce boilerplate code by offering you macros and code generation.Nothing obscure or magic, the code is really readable and comprehensive.","ref":"readme.html","title":"Umbra","type":"extras"},{"doc":"Add umbra for Elixir as a dependency in your mix.exs file.def deps do [ {:umbra, &quot;~&gt; 0.0.2&quot;}, ] endAfter you are done, run this in your shell to fetch the new dependency:$ mix deps.get","ref":"readme.html#installation","title":"Umbra - Installation","type":"extras"},{"doc":"To get started, after adding the dependency to your mix project, you only have to use the Umbra.GenServer and the codes did starts to be generated.Here is a really simple exemple:defmodule BasicGenServer do use Umbra.GenServer definit do: {:ok, state} defcall {:get_state}, do: {:reply, state, state} defcast {:set_state, new_state}, do: {:noreply, new_state} defcast {:increment}, do: {:noreply, state + 1} defcast {:decrement}, do: {:noreply, state - 1} end {:ok, pid} = BasicGenServer.start_link(0) # state = 0 :ok = BasicGenServer.increment(pid) # state = 1 :ok = BasicGenServer.increment(pid) # state = 2 :ok = BasicGenServer.decrement(pid) # state = 1 :ok = BasicGenServer.set_state(pid, 42) # state = 42 {:ok, 42} = BasicGenServer.get_state(pid)To deep further, please take a look at HexDocs.","ref":"readme.html#getting-started","title":"Umbra - Getting started","type":"extras"},{"doc":"The project is tested for:Elixir versionOTP version1.7.419.41.7.420.31.7.421.31.7.422.31.8.220.31.8.221.31.8.222.31.9.420.31.9.421.31.9.422.31.10.321.31.10.322.31.10.323.0","ref":"readme.html#tests","title":"Umbra - Tests","type":"extras"},{"doc":"Contributions are welcome!Fork it!Create your feature branch (git checkout -b your-new-feature).Commit your change in only one commit (git commit -am &quot;Add my new feature&quot;).Push your change on your fork (git push origin your-new-feature).Create a new Pull Request.","ref":"readme.html#contributing","title":"Umbra - Contributing","type":"extras"},{"doc":"Sylvain Corsini (@scorsi)","ref":"readme.html#author","title":"Umbra - Author","type":"extras"},{"doc":"The project took inspiration from the well-known ExActor.","ref":"readme.html#credits","title":"Umbra - Credits","type":"extras"}]